/* printfiles Arexx Macro                              */
/*  1992 by K. Klingbeil                              */
/* fgt Dateinamen mittels pattern-matching in die     */
/* Druckliste ein                                      */
/* Befehl   : rx prf [Einfgepattern] -r[Lschpattern] */
/*                   -f[ArexxMakro]                    */
/* Beispiel : rx prf  #?.c #?.h -rtest#?.c  -rtest.h   */
/*            fgt alle Dateien im aktuellen           */
/*            Verzeichnis, die auf .c oder .h enden in */
/*            die Druckliste und lscht alle dateien   */
/*            die test im Namen mit der Endung .c      */
/*            und die Datei test.h                     */
/* ArexxMakro ist der Name eines Arexx-Programms, das  */
/* dabei ausgefhrt werden soll (z.B. fr Voreinstell- */
/* ungen)                                              */
/* Anmerkung: von Printfiles generierte Arexx-Programme*/
/* sollten das erste Argument sein, da sie zu Beginn   */
/* einen reset-Befehl beinhalten                       */
/* Beispiel fr die richtige Reihenfolge:              */
/* rx prf -fPrintfiles.makro #?.c -rtest.c             */

options results
address command 'rx prfstart' /* printfiles starten    */
if result = 5 then exit       /* konnte nicht starten  */

parse arg CmdLine
p = words(CmdLine)

do i = 1 to p
   pattern = word(CmdLine,i)
   if left(pattern,2) == '-r' then removefile(substr(pattern,3))
    else
     if left(pattern,2) == '-f' then rxfile(substr(pattern,3))
      else insertfile(pattern)
end
exit

rxfile: procedure
parse arg template
cmd =  'rx ' template
address command cmd
return 1

removefile: procedure
parse arg template
cmd =  'list >pipe:prf' template 'quick'
address command cmd
address printfiles
open('p','pipe:prf','r')
 do while ~eof('p')
  file = readln('p')
  a = subword(file,1,1)
  b = subword(file,2,1)
  if a ~== '' & b == '' then remfile a
 end
close('p')

return 1

insertfile: procedure
parse arg template
cmd =  'list >pipe:prf' template 'quick'
address command cmd
address printfiles
open('p','pipe:prf','r')
 do while ~eof('p')
  file = readln('p')
  a = subword(file,1,1)
  b = subword(file,2,1)
  if a ~== '' & b == '' then insfile a
 end
close('p')
return  1

